; Open a file cs:dx = pName, return length in dx:ax

Open_File:	xor ax,ax		; Clear handle and base
		mov cs:FileHandle,ax	;

		push cs			; Use CS
		pop ds			;

		mov al,00h		; Read only

		mov ah,OpenFile		; Call dos
		int dos			;

		jc OF_Fail		; Can't (use nearest)

		mov cs:FileHandle,ax	; Save handle

		mov bx,ax		; Get length

		xor cx,cx		; Zero
		xor dx,dx		;

		mov al,2		; From end
	
		mov ah,MovePointer	;
		int dos			;

		jc OF_Fail_Close	; Can't

		push dx			; Save dx
		push ax			;

		; Rewind

		call Rewind_File	; Rewind it

		; Restore length

		pop ax			;
		pop dx			;

		; Exit with this length

		clc			; NC
OF_Fail:	ret			;

	; Failure case

OF_Fail_Close:	call Close_File		; Close the file

		stc			; Fail
		ret			;

; Close the file

Close_File:	push dx			; Save
		push cx			;
		push bx			;
		push ax			;

		mov bx,cs:FileHandle	; Close it
		cmp bx,0		; Open ?
		je CF_X			; No, don't bother

		mov ah,CloseFile	; Close the output file
		int dos			;

CF_X:		pop ax			; Restore
		pop bx			;
		pop cx			;
		pop dx			;

		ret			;

; Rewind file

Rewind_File:	push dx			; Save
		push cx			;
		push bx			;
		push ax			;

		; Clear the buffer

		mov w cs:File_Buff_L,0	; None

		; Rewind the file ptr

		xor cx,cx		; 0
		xor dx,dx		;

		mov bx,cs:FileHandle	;

		mov al,0		;

		mov ah,MovePointer	;
		int dos			;

		pop ax			;
		pop bx			;
		pop cx			;
		pop dx			;

		ret			; Done

; Get the next character of the file

Get_File_Char:	push bx			; Save

		; Any chars in the buffer ?

GFC_1:		mov bx,cs:File_Buff_L	; Get the remaining length
		cmp bx,0		; Any ?
		je GFC_Next		; None, get the next block

		dec bx			; One less
		mov cs:File_Buff_L,bx	;

		; We have a char, get it

		mov bx,cs:pFile_Buff	; Get the ptr
		mov al,cs:[bx]		; Get the char

		inc bx			; Save the new ptr
	
		mov cs:pFile_Buff,bx	; New ptr

		pop bx			; Restore

		clc			; Ok
		ret			; Done

	; Get another block

GFC_Next:	push dx			; Save
		push cx			;
		push ds			;

		; Read the next sector

		push cs			; Use CS
		pop ds			;

		mov dx,o File_Buffer	; Offset
		mov cs:pFile_Buff,dx	; Point at the start

		mov bx,cs:FileHandle	; Get file handle

		mov cx,512		; 512 bytes at a time

		mov ah,ReadFromFile	; Read it
		int dos			;

		; Recover the stack

		pop ds			; Restore
		pop cx			;
		pop dx			;

		; Ok ?

		jc GFC_Fail		; Error, EOF

		; Now, save the length read

		mov cs:File_Buff_L,ax	; Save the length

		; Is this 0 ?

		cmp ax,0		; Any in the buffer ?
		jne GFC_1		; Yes, try again

		; Right, EOF

GFC_Fail:	stc			; Fail

		pop bx			; Restore
		ret			; Done

; Vars

FileHandle	dw 0			; File handle

File_Buff_L	dw 0			; Bytes in the buffer
pFile_Buff	dw 0			; Ptr to file buffer

File_Buffer	db 512 dup (0)		; Buffer here
