; All these sources/objects are (c) Simon Brattel 1993

; This interfaces the game to the front-end code, all the shit lives here . .

		.486

		include ..\symbols.inc	; Define some symbols

		include gsymbols.inc	; Some more

CODE		SEGMENT public para use16 ;

		ASSUME  CS:CODE	;

; Code to setup the game, this gets the buffers

Init_Games:	mov bx,(16*16*16*8 + nCols*3)/16 + 1; Foreground blocks

		; Allocate this much

		mov ah,Allocate_Mem	; Call DOS
		int dos			;
		jc IG_X			; Exit

		mov cs:Block_Defns,ax	; Save this buffer

		call Get_Buff_RAM	; Allocate them
		jc IG_X			; Fail

		; Clear the vars

		mov ax,0		; 0
		mov cs:Frame_No,ax	;

		clc			; Ok

IG_X:		retf			; Done

; Code to exit the game

End_Games:	retf			; Done

; Play a game

Play_Game:	call Play_One		; Play one

		mov ax,0		; Kill the score
		retf			; Done

; Code drivers

Frame_Lock:	call far ptr F_Frame_Lock ; Call it

		inc w cs:Frame_No	  ; Step it

		ret			  ;

; Set the video modes

Set_320_200:	mov al,013h		; VGA 320.200 256 colour

		mov ah,0		; Set mode
		int vdu			;

		; Set the colours

		mov cl,0		; Black
		call Fade_Palette	;

		; Done

		ret			; Done

		; Includes

		include free.inc	; Drive the free-space list

		include palette.inc	; The initial colours

		include game.inc	; The real code

		include utils.inc	; Some useful code

; Vars
		align 2			; Even

Buff_Seg	dw 0			; The first buffer

Block_Defns	dw 0			; The sprite defns

Frame_No	dw ?			; The frame no.

CODE		ends

		extrn F_Link_Kbd	:far
		extrn F_Unlink_Kbd	:far

		extrn F_Frame_Lock	:far

		extrn F_Read_File	:far
		extrn F_Write_File	:far

		extrn Test_Left		:far
		extrn Test_Right	:far
		extrn Test_Up		:far
		extrn Test_Down		:far
		extrn Test_Fire		:far
		extrn Test_Esc		:far
		extrn Test_Boss		:far
		extrn Test_Pause	:far

		extrn Test_F1		:far
		extrn Test_F2		:far
		extrn Test_F3		:far
		extrn Test_F4		:far
		extrn Test_F5		:far
		extrn Test_F6		:far
		extrn Test_F7		:far
		extrn Test_F8		:far
		extrn Test_F9		:far
		extrn Test_F10		:far
		extrn Test_F11		:far
		extrn Test_F12		:far

		extrn Test_UA		:far
		extrn Test_DA		:far

		public Init_Games	; Start them
		public End_Games	; End them
		public Play_Game	; Play one

		extrn Col_Cycle		:near

		extrn Swing_1		:near
		extrn Swing_2		:near

		end
