; Show some introductory text

Init_Intro:	mov b cs:Key_Pressed,0	; Not yet

		mov w cs:Intro_Y,-5*70	; Wait 5 seconds

		mov b cs:Intro_SR,4	; Scroll rate

		ret			; Done

; Scroll the intro text

Show_Intro:	mov al,cs:Intro_SR	; Get the rate
		cmp al,0		;
		je SIn_X		; Done, exit

		; Are we waiting ?

		cmp w cs:Intro_Y,0	; neg ?
		js SIn_Wait		; No, skip

		; Now, has a key been pressed ?

		test b cs:Key_Pressed,-1 ; Pressed ?
		jne SIn_Kill		 ; Yes, kill it

		cbw			; 16-bit

		; No, show the text

		mov cx,cs:Intro_Y	; Get the Y
		add cx,ax		; Scroll rate
		mov cs:Intro_Y,cx	;

		shr cx,1		; /8
		shr cx,1		;
		shr cx,1		;

		neg cx			; -ve

		add cx,cs:Screen_Y	; Move down
		add cx,View_Height-5	;

		; Now, show the text

		mov si,o Intro_Text	; Point at it

		mov b cs:Intro_NS,1	; Flag none yet

SIn_Lp:		call SI_Line		; One line
		jc SIn_End		; Skip if out-of-range

		add cx,13		; Move down

		jmp s SIn_Lp		; Loop

SIn_End:	test b cs:Intro_NS,-1	; Any ?
		je SIn_X		; Yes, skip

SIn_Kill:	mov b cs:Intro_SR,0	; Kill it

SIn_X:		ret			; Done

SIn_Wait:	inc w cs:Intro_Y	; One less
		ret			;

	; Show a line of text

SI_Line:	mov ax,cs:Screen_Y	; Get the top-of-screen
		sub ax,10		; Move up

		cmp cx,ax		; In range ?
		jc SIL_Skip		; No, skip
		js SIL_Skip

		add ax,View_Height+20	; Move down

		cmp cx,ax		; In range
		jnc SIL_Done		; No, skip

		; Show this line

		mov bx,cs:Screen_X	; X

		mov dx,cx		; Point at the Y

		mov b cs:Intro_NS,0	; Flag valid

		push cx			; Save
		call ST_Line		; Show it
		pop cx			; Restore

SIL_1:		mov al,cs:[si]		; End ?
		cmp al,0		;
		je SIL_Done		; Yes, exit

		clc			; Ok
		ret			; Done

SIL_Done:	stc			; CF
		ret			; Done

	; Skip this line

SIL_Skip:	mov al,cs:[si]		; Get it
		inc si			; Skip

		cmp al,020h		; End ?
		jnc SIL_Skip		; No, loop

		jmp s SIL_1		; As above

; Fixed data

Intro_Text	db "The story so far . . .",0
		db " ",0
		db "Doctor StrangeFruit, a genetic",0
		db "engineer of some renown, is",0
		db "trapped in his laboratory with",0
		db "some of his latest creations.",0
		db " ",0
		db " ",0
		db " ",0
		db "He is not a happy man.",0
		db " ",0
		db " ",0
		db " ",0
		db "He has begun to regret his",0
		db "decision to write the gene",0
		db "editing software in 'C'.",0
		db " ",0
		db " ",0
		db " ",0
		db "However, he has just made an",0
		db "even bigger mistake.",0
		db " ",0
		db " ",0
		db " ",0
		db "He used the resulting code.",0
		db " ",0
		db " ",0
		db " ",0
		db "Dr. StrangeFruit is about to",0
		db "have a very bad day !",0
		db 0

; Vars

Key_Pressed	db ?		; NZ = a key pressed
Intro_Y		dw ?		; Scroll count
Intro_NS	db ?		; NZ = blank
Intro_SR	db ?		; Rate of scrolling
