; This creates the look-up table, given si = ^initial, di = ^table

Init_Move_Pall:	mov si,o Back_Pal	; Source
		mov di,o Back_P_Tab	; Dest

		; Build the table

		call IMP_Build		;

		mov si,o Fore_Pal	; Source
		mov di,o Fore_P_Tab	; Dest

		; Build the table

IMP_Build:	call IMP_Lp1		; Do it twice

		; Again

IMP_Lp1:	push si			; Save

		mov cx,8		; Copy 8 lines

IMP_Lp2:	push cx			; Save

		mov cx,24		; Copy 8 colours
		call IMP_Copy		;
		mov cx,24		;
		call IMP_Copy		;

		lea si,24[si]		; Skip 8 colours

		pop cx			; Restore

		loop IMP_Lp2		; Loop

		pop si			; Restore

		ret			; Done

	; Copy cx bytes from cs:si to cs:di

IMP_Copy:	push si			; Save

IMPC_Lp:	mov al,cs:[si]		; Copy
		inc si			;
		shr al,1		; /4
		mov ah,al
		shr ah,1		;
;		add al,ah
		and al,3Fh
		mov cs:[di],al		;
		inc di			;

		loop IMPC_Lp		; Loop

		pop si			; Restore
		ret			;

; Write the palette

; Drive the background palette

Drive_Back_Pall:mov ax,cs:Screen_Y	; Calc the palette offset
		shr ax,1		; /2
		and ax,07h		; Mask

		add ax,ax		; * 16
		add ax,ax		;
		add ax,ax		;
		add ax,ax		;

		mov bx,cs:Screen_X	; Calc the X offset
		shr bx,1		; /2
		and bx,07h		; Mask

		add ax,bx		; Combine

		mov bx,ax		; * 3
		add bx,bx		;
		add bx,ax		;

		add bx,o Back_P_Tab	; Point at the data

		mov al,0C0h		; Start at this colour
		mov cx,0808h		; 8 by 8
		call Write_Palette	; Write the palette		

		; Now, drive the cycling colour

		mov al,cs:Col_Phase	; Get it
		inc al			; Step
		mov cs:Col_Phase,al	;

;		and al,1Fh		; 0 .. 31
		mov ah,0		; 16-bit

		mov bx,ax		; bx := ax*3
		add ax,ax		;
		add bx,ax		;

		add bx,o Col_Cycle	; Point at it

		jmp s Write_Phase	; Write them

; Write phase colours

Write_Phase:	mov dx,03C8h		; Address register
		mov al,018h		; The colour
		out dx,al		; Set the address

		jmp $+2			; Delay
		jmp $+2			;

		inc dx			; Change the address

		mov ch,8		; This many colours
		mov cl,2		; / 4

		; Now write a block of 1 colours

WPh_Lp:		mov al,cs:[bx]		; Get the red
		shr al,cl		;
		out dx,al		; Write it

		inc bx			; Step the ptr

		jmp $+2			; Delay
		jmp $+2			;

		mov al,cs:[bx]		; Get the red
		shr al,cl		;
		out dx,al		; Write it

		inc bx			; Step the ptr

		jmp $+2			; Delay
		jmp $+2			;

		mov al,cs:[bx]		; Get the red
		shr al,cl		;
		out dx,al		; Write it

		inc bx			; Step the ptr

		jmp $+2			; Delay
		jmp $+2			;

		; Wrap around

		cmp bx,o Col_Cycle+100h*3 ; End ?
		jb WPh_Next		; No, skip

		mov bx,o Col_Cycle	; Wrap

WPh_Next:	dec ch			; Loop
		jnz WPh_Lp		;

		ret			; Done

; Write all the colours

Write_All_Palette:
		mov cx,01C0h		; One by 3*8*8
		mov al,0		;
		mov bx,o Palette	;

	; Write cx colours entry al from cs:bx

Write_Palette:	mov dx,03C8h		; Address register
		out dx,al		; Set the address

		jmp $+2			; Delay
		jmp $+2			;

		inc dx			; Change the address

		; Now write a block of 8*8 colours

WP_Lp:		mov ax,cs:[bx]		; Get the red
		out dx,al		; Write it

		jmp $+2			; Delay
		jmp $+2			;

		mov al,ah		; Get the green
		out dx,al		; Write it

		add bx,2		; Step the ptr

		jmp $+2			; Delay
		jmp $+2			;

		mov al,cs:[bx]		; Get the blue
		out dx,al		; Write it

		inc bx			; Step the ptr

		jmp $+2			; Delay
		jmp $+2			;

		dec cl			; Loop
		jnz WP_Lp		;

		add bx,8*3		; Skip the copy

		mov cl,8		; Copy 8 colours

		dec ch			; Loop
		jnz WP_Lp		;

		ret			; Done

; Fade the palette

; Write all the colours, scaled

Fade_Palette:	mov bx,o Palette	; Point at it
		mov al,0

		mov dx,03C8h		; Address register
		out dx,al		; Set the address

		jmp $+2			; Delay
		jmp $+2			;

		inc dx			; Change the address

		; Now write all the colours

		mov ch,3*8*8		; All of them

FP_Lp:		mov al,cs:[bx]		; Get the red
		mul cl			; Scale

		mov al,ah		;
		out dx,al		; Write it

		jmp $+2			; Delay
		jmp $+2			;

		mov al,cs:1[bx]		; Get the green
		mul cl			; Scale

		mov al,ah		;
		out dx,al		; Write it

		jmp $+2			; Delay
		jmp $+2			;

		mov al,cs:2[bx]		; Get the blue
		mul cl			; Scale

		mov al,ah		;
		out dx,al		; Write it

		add bx,3		; Step the ptr

		jmp $+2			; Delay
		jmp $+2			;

		dec ch			; Loop
		jnz FP_Lp		;

		ret			; Done

; These are the default colours

Palette		db 00h,00h,00h		; 00 Grey-Scale for the background

		db 10h,10h,10h		; 01
		db 14h,14h,14h		; 02
		db 08h,08h,08h		; 03

		db 20h,20h,20h		; 04
		db 28h,28h,28h		; 05
		db 30h,30h,30h		; 06
		db 38h,38h,38h		; 07
		db 3Fh,3Fh,3Fh		; 08

		db 0Ch,0Ch,10h		; 09
		db 0Ch,0Ch,14h		; 0A
		db 0Ch,0Ch,18h		; 0B
		db 08h,0Ch,20h		; 0C
		db 04h,0Ch,28h		; 0D
		db 00h,0Ch,30h		; 0E
		db 00h,0Ch,38h		; 0F

		db 00h,2Fh,3Fh		; 10 Sky
		db 00h,2Dh,3Dh		; 11
		db 00h,2Ch,3Bh		; 12
		db 00h,2Bh,39h		; 13
		db 00h,00h,3Fh		; 14

		db 3fh,10h,08h		; 15
		db 3fh,3fh,00h		; 16
		db 3fh,2Ch,3Ch		; 17
		db 08h,08h,34h		; 18

		db 10h,04h,34h		; 19 Text blue
		db 08h,08h,38h		; 1A
		db 00h,0Ch,38h		; 1B
		db 00h,10h,3Ch		; 1C
		db 18h,18h,3Ch		; 1D
		db 00h,10h,3Ch		; 1E
		db 00h,0Ch,38h		; 1F

		db 10h,10h,10h		; 20 ; Explosion colours
		db 3fh,3fh,10h		; 21
		db 3fh,10h,20h		; 22
		db 3fh,20h,30h		; 23
		db 3fh,20h,30h		; 24
		db 3fh,20h,18h		; 25
		db 3fh,20h,28h		; 26
		db 3fh,20h,38h		; 27
		db 3fh,20h,20h		; 28
		db 3fh,30h,30h		; 29
		db 3fh,32h,20h		; 2A
		db 3fh,38h,30h		; 2B
		db 3fh,3fh,00h		; 2C
		db 3fh,30h,3Ch		; 2D
		db 3fh,3ch,00h		; 2E
		db 3fh,3Ch,3Ch		; 2F

		db 2Ch,3Ch,3Ch		; 30 ; Ship
		db 0Ch,28h,2Ch		; 31
		db 00h,20h,24h		; 32
		db 3Ch,00h,00h		; 33

		db 3Ch,3Ch,00h		; 34 Flames
		db 2Ch,2Ch,00h		; 35
		db 3Ch,00h,00h		; 36
		db 3Ch,3Ch,2Ch		; 37

		db 00h,20h,00h		; 38
		db 00h,24h,00h		; 39
		db 00h,28h,00h		; 3A
		db 00h,2Ch,00h		; 3B
		db 00h,30h,00h		; 3C
		db 00h,34h,00h		; 3D
		db 00h,38h,00h		; 3E
		db 00h,3Ch,00h		; 3F

		db 00h,00h,00h		; 40
		db 00h,00h,04h		; 41
		db 00h,00h,08h		; 42
		db 00h,00h,0Ch		; 43
		db 00h,00h,10h		; 44
		db 00h,00h,14h		; 45
		db 00h,00h,18h		; 46
		db 00h,00h,1Ch		; 47
		db 00h,00h,20h		; 48
		db 00h,00h,24h		; 49
		db 00h,00h,28h		; 4A
		db 00h,00h,2Ch		; 4B
		db 00h,00h,30h		; 4C
		db 00h,00h,34h		; 4D
		db 00h,00h,38h		; 4E
		db 00h,00h,3Ch		; 4F

		db 00h,00h,00h		; 50
		db 04h,04h,04h		; 51
		db 08h,08h,08h		; 52
		db 0Ch,0Ch,0Ch		; 53
		db 10h,10h,10h		; 54
		db 14h,14h,14h		; 55
		db 18h,18h,18h		; 56
		db 1Ch,1Ch,1Ch		; 57
		db 20h,20h,20h		; 58
		db 24h,24h,24h		; 59
		db 28h,28h,28h		; 5A
		db 2Ch,2Ch,2Ch		; 5B
		db 30h,30h,30h		; 5C
		db 34h,34h,34h		; 5D
		db 38h,38h,38h		; 5E
		db 3Ch,3Ch,3Ch		; 5F

		db 00h,00h,00h		; 60
		db 04h,04h,04h		; 61
		db 08h,08h,08h		; 62
		db 0Ch,0Ch,0Ch		; 63
		db 10h,10h,10h		; 64
		db 14h,14h,14h		; 65
		db 18h,18h,18h		; 66
		db 1Ch,1Ch,1Ch		; 67
		db 20h,20h,20h		; 68
		db 24h,24h,24h		; 69
		db 28h,28h,28h		; 6A
		db 2Ch,2Ch,2Ch		; 6B
		db 30h,30h,30h		; 6C
		db 34h,34h,34h		; 6D
		db 38h,38h,38h		; 6E
		db 3Ch,3Ch,3Ch		; 6F

		db 00h,00h,00h		; 70
		db 04h,04h,04h		; 71
		db 08h,08h,08h		; 72
		db 0Ch,0Ch,0Ch		; 73
		db 10h,10h,10h		; 74
		db 14h,14h,14h		; 75
		db 18h,18h,18h		; 76
		db 1Ch,1Ch,1Ch		; 77
		db 20h,20h,20h		; 78
		db 24h,24h,24h		; 79
		db 28h,28h,28h		; 7A
		db 2Ch,2Ch,2Ch		; 7B
		db 30h,30h,30h		; 7C
		db 34h,34h,34h		; 7D
		db 38h,38h,38h		; 7E
		db 3Ch,3Ch,3Ch		; 7F

	; The foreground palette colours

Fore_Pal:	db 20h,00h,00h		; 80
		db 20h,00h,00h		; 81
		db 20h,00h,00h		; 82
		db 20h,00h,00h		; 83
		db 10h,10h,00h		; 84
		db 10h,10h,00h		; 85
		db 10h,10h,00h		; 86
		db 10h,10h,00h		; 87

		db 20h,00h,00h		; 80
		db 30h,00h,00h		; 81
		db 30h,00h,00h		; 82
		db 20h,00h,00h		; 83
		db 10h,10h,00h		; 84
		db 08h,08h,00h		; 85
		db 08h,08h,00h		; 86
		db 10h,10h,00h		; 87

		db 20h,00h,00h		; 80
		db 30h,00h,00h		; 81
		db 30h,00h,00h		; 82
		db 20h,00h,00h		; 83
		db 10h,10h,00h		; 84
		db 08h,08h,00h		; 85
		db 08h,08h,00h		; 86
		db 10h,10h,00h		; 87

		db 20h,00h,00h		; 80
		db 20h,00h,00h		; 81
		db 20h,00h,00h		; 82
		db 20h,00h,00h		; 83
		db 10h,10h,00h		; 84
		db 10h,10h,00h		; 85
		db 10h,10h,00h		; 86
		db 10h,10h,00h		; 87

		db 10h,10h,00h		; 80
		db 10h,10h,00h		; 81
		db 10h,10h,00h		; 82
		db 10h,10h,00h		; 83
		db 20h,00h,00h		; 84
		db 20h,00h,00h		; 85
		db 20h,00h,00h		; 86
		db 20h,00h,00h		; 87

		db 10h,10h,00h		; 80
		db 08h,08h,00h		; 81
		db 08h,08h,00h		; 82
		db 10h,10h,00h		; 83
		db 20h,00h,00h		; 84
		db 30h,00h,00h		; 85
		db 30h,00h,00h		; 86
		db 20h,00h,00h		; 87

		db 10h,10h,00h		; 80
		db 08h,08h,00h		; 81
		db 08h,08h,00h		; 82
		db 10h,10h,00h		; 83
		db 20h,00h,00h		; 84
		db 30h,00h,00h		; 85
		db 30h,00h,00h		; 86
		db 20h,00h,00h		; 87

		db 10h,10h,00h		; 80
		db 10h,10h,00h		; 81
		db 10h,10h,00h		; 82
		db 10h,10h,00h		; 83
		db 20h,00h,00h		; 84
		db 20h,00h,00h		; 85
		db 20h,00h,00h		; 86
		db 20h,00h,00h		; 87

	; The background palette colours

	; The background palette colours

Back_Pal:	db 00h,00h,00h		; 80
		db 04h,04h,04h		; 81
		db 08h,08h,0Ch		; 82
		db 0Ch,0Ch,14h		; 83
		db 10h,10h,20h		; 84
		db 0Ch,0Ch,14h		; 85
		db 08h,08h,0Ch		; 86
		db 04h,04h,04h		; 87

		db 04h,04h,04h		; 80
		db 08h,08h,08h		; 81
		db 0ch,0ch,10h		; 82
		db 10h,10h,18h		; 83
		db 14h,14h,24h		; 84
		db 10h,10h,18h		; 85
		db 0ch,0ch,10h		; 86
		db 08h,08h,08h		; 87

		db 08h,08h,08h		; 80
		db 0ch,0ch,0ch		; 81
		db 10h,10h,14h		; 82
		db 14h,14h,1ch		; 83
		db 18h,18h,28h		; 84
		db 14h,14h,1ch		; 85
		db 10h,10h,14h		; 86
		db 0ch,0ch,0ch		; 87

		db 0ch,0ch,14h		; 80
		db 10h,10h,18h		; 81
		db 14h,14h,20h		; 82
		db 18h,18h,28h		; 83
		db 24h,24h,34h		; 84
		db 18h,18h,28h		; 85
		db 14h,14h,18h		; 86
		db 10h,10h,18h		; 87

		db 10h,10h,20h		; 80
		db 14h,14h,24h		; 81
		db 18h,18h,2Ch		; 82
		db 1Ch,1Ch,34h		; 83
		db 28h,28h,3Fh		; 84
		db 1Ch,1Ch,34h		; 85
		db 18h,18h,2Ch		; 86
		db 14h,14h,24h		; 87

		db 0ch,0ch,14h		; 80
		db 10h,10h,18h		; 81
		db 14h,14h,20h		; 82
		db 18h,18h,28h		; 83
		db 24h,24h,34h		; 84
		db 18h,18h,28h		; 85
		db 14h,14h,18h		; 86
		db 10h,10h,18h		; 87

		db 08h,08h,08h		; 80
		db 0ch,0ch,0ch		; 81
		db 10h,10h,14h		; 82
		db 14h,14h,1ch		; 83
		db 18h,18h,28h		; 84
		db 14h,14h,1ch		; 85
		db 10h,10h,14h		; 86
		db 0ch,0ch,0ch		; 87

		db 04h,04h,04h		; 80
		db 08h,08h,08h		; 81
		db 0ch,0ch,10h		; 82
		db 10h,10h,18h		; 83
		db 14h,14h,24h		; 84
		db 10h,10h,18h		; 85
		db 0ch,0ch,10h		; 86
		db 08h,08h,08h		; 87

;Back_Pal:	db 00h,00h,00h		; 80
		db 04h,04h,04h		; 81
		db 08h,08h,0Ch		; 82
		db 0Ch,0Ch,14h		; 83
		db 10h,10h,20h		; 84
		db 0Ch,0Ch,14h		; 85
		db 08h,08h,0Ch		; 86
		db 04h,04h,04h		; 87

		db 04h,04h,04h		; 80
		db 08h,08h,08h		; 81
		db 0ch,0ch,10h		; 82
		db 10h,10h,18h		; 83
		db 14h,14h,24h		; 84
		db 10h,10h,18h		; 85
		db 0ch,0ch,10h		; 86
		db 08h,08h,08h		; 87

		db 08h,08h,08h		; 80
		db 0ch,0ch,0ch		; 81
		db 10h,10h,14h		; 82
		db 14h,14h,1ch		; 83
		db 18h,18h,28h		; 84
		db 14h,14h,1ch		; 85
		db 10h,10h,14h		; 86
		db 0ch,0ch,0ch		; 87

		db 0ch,0ch,14h		; 80
		db 10h,10h,18h		; 81
		db 14h,14h,20h		; 82
		db 18h,18h,28h		; 83
		db 24h,24h,34h		; 84
		db 18h,18h,28h		; 85
		db 14h,14h,18h		; 86
		db 10h,10h,18h		; 87

		db 10h,10h,20h		; 80
		db 14h,14h,24h		; 81
		db 18h,18h,2Ch		; 82
		db 1Ch,1Ch,34h		; 83
		db 28h,28h,3Fh		; 84
		db 1Ch,1Ch,34h		; 85
		db 18h,18h,2Ch		; 86
		db 14h,14h,24h		; 87

		db 0ch,0ch,14h		; 80
		db 10h,10h,18h		; 81
		db 14h,14h,20h		; 82
		db 18h,18h,28h		; 83
		db 24h,24h,34h		; 84
		db 18h,18h,28h		; 85
		db 14h,14h,18h		; 86
		db 10h,10h,18h		; 87

		db 08h,08h,08h		; 80
		db 0ch,0ch,0ch		; 81
		db 10h,10h,14h		; 82
		db 14h,14h,1ch		; 83
		db 18h,18h,28h		; 84
		db 14h,14h,1ch		; 85
		db 10h,10h,14h		; 86
		db 0ch,0ch,0ch		; 87

		db 04h,04h,04h		; 80
		db 08h,08h,08h		; 81
		db 0ch,0ch,10h		; 82
		db 10h,10h,18h		; 83
		db 14h,14h,24h		; 84
		db 10h,10h,18h		; 85
		db 0ch,0ch,10h		; 86
		db 08h,08h,08h		; 87


; Palette buffer

Back_P_Tab:	db 8 * 3 * 2 * 8 * 2 dup (?) ; The background look-up table
Fore_P_Tab:	db 8 * 3 * 2 * 8 * 2 dup (?) ; The background look-up table

Col_Phase	db ?			; The cycling colour's phase
