dpFlags		equ 0			; Platform flags
dpX		equ 2			;
dpY		equ 4			;
dpPos		equ 6			;
dpMax		equ 8			;
dpDirn		equ 10			;
dpD		equ 12			;
dpE		equ 14			;
dpF		equ 16			;

dppMove		equ 18			;
dppDraw		equ 20			;
dppTable	equ 22			;
dppOccupier	equ 24			; Point at the dX/dY

lPlat		equ 32;24		; Length

mff_Grav	equ 10			; Gravity

Bridge_Man_F	equ 330			; 'Weight' of player

; This drives the platforms about

Init_Platforms:	mov di,o Platforms	; Point at the workspace

		mov si,o pPlats		; Point at the defns
		add si,cs:[si]		;

IP_Lp:		mov ax,cs:6[si]		; Copy pos
		mov cs:dpPos[di],ax	;
		mov ax,cs:8[si]		; Copy max
		mov cs:dpMax[di],ax	;
		mov ax,cs:10[si]	; Copy dirn
		mov cs:dpDirn[di],ax	;
		mov ax,cs:12[si]	; Copy D
		mov cs:dpD[di],ax	;
		mov ax,cs:14[si]	; Copy E
		mov cs:dpE[di],ax	;
		mov ax,cs:16[si]	; Copy F
		mov cs:dpF[di],ax	;

		mov bx,cs:[si]		; X
		mov dx,cs:2[si]		; Y

		mov ax,cs:4[si]		; Type

		call Setup_Platform	; Create it

		lea si,18[si]		; Skip

		test w cs:[si],-1	; End ?
		jnz IP_Lp		; No, loop

		ret			; Done

; Setup a platform bx:dx = posn, ax = type

Setup_Platform:	mov w cs:dpFlags[di],1	; Flags
		mov cs:dpX[di],bx	; X
		mov cs:dpY[di],dx	; Y

		; Now, look at the type

		mov bx,o Move_Swing	; Swing
		mov cx,o Draw_Swing	;
		mov dx,o Swing_1	;

		cmp al,1		; Big swing ?
		je StP_1		; Yes, skip

		mov dx,o Swing_2	; Bigger

		cmp al,2		; Small swing ?
		je StP_1		; Yes, skip

		mov cx,o Draw_Cordless	;
		mov dx,o Swing_1	;

		cmp al,3		; Big swing free ?
		je StP_1		; Yes, skip

		mov dx,o Swing_2	; Bigger

		cmp al,4		; Small swing free ?
		je StP_1		; Yes, skip

		mov bx,o Move_Spring	; Spring
		mov cx,o Draw_Spring	; 

		cmp al,10		; Flag setter ?
		je StP_1		; Yes, skip

		mov bx,o Move_Float	; Floater
		mov cx,o Draw_Flat	;

		cmp al,20		; Floater ?
		je StP_1		; Yes, skip

		mov bx,o Move_F_Latch	; Latching floater

		cmp al,21		; Latching floater ?
		je StP_1		; Yes, skip

		mov bx,o Move_F_Fall	; Falling floater

		cmp al,22		; Falling floater ?
		je StP_1		; Yes, skip

		; 23 .. 29 reserved

		mov bx,o Move_Bridge_L	; Bridge
		mov cx,o Draw_Bridge	;

		cmp al,30		; LHS ?
		je StP_1		; Yes, skip

		mov bx,o Move_Bridge_M	; Bridge

		cmp al,31		; Middle ?
		je StP_1		; Yes, skip

		mov bx,o Move_Bridge_R	; Bridge

		cmp al,32		; Rhs ?
		je StP_1		; Yes, skip

		mov bx,o Move_Bridge_S	; Bridge

		cmp al,33		; Rhs ?
		je StP_1		; Yes, skip

		; Assume floater

		mov w cs:dpPos[di],0	; Posn, etc
		mov w cs:dpMax[di],171	; Maxm
		mov w cs:dpDirn[di],1	; Dirn	

		mov bx,o Move_Swing	; Swing
		mov cx,o Draw_Swing	;
		mov dx,o Swing_1	;

StP_1:		mov cs:dppMove[di],bx	; Move
		mov cs:dppDraw[di],cx	; Show
		mov cs:dppTable[di],dx	; Table

		; Done, exit

StP_End:	lea di,lPlat[di]	; Point at the next

		mov w cs:dpFlags[di],0	; Next

		ret			; Done

; Move them

Move_Platforms:	mov di,o Platforms	; The first

MPlat_Lp:	mov bx,cs:dppMove[di]	; Move it
		call bx			;

		lea di,lPlat[di]	; Skip it

		test w cs:dpFlags[di],1	; Alive ?
		jnz MPlat_Lp		; Yes, do it

		ret			; Done

; Draw them

Draw_Platforms:	mov di,o Platforms	; The first

DPlat_Lp:	mov bx,cs:dppDraw[di]	; Move it
		call bx			;

		lea di,lPlat[di]	; Skip it

		test w cs:dpFlags[di],1	; Alive ?
		jnz DPlat_Lp		; Yes, do it

		ret			; Done

; Move a spring

Move_Spring:	test b cs:dpFlags[di],2	; Is the player standing on this plat ?
		je MF_1			; No, skip

		and b cs:dpFlags[di],0FDh ; Clear the flag

		; Make the spring move

		mov w cs:dpPos[di],o Spring_Tab	; Bounce

		; Cause something to happen

		mov ax,cs:dpDirn[di]	; Jump
		mov bx,cs:dppOccupier[di] ; Point at the dY

;		mov ax,cs:2[bx]		  ; Impact
;		neg ax
;		sub ax,80
		add cs:[bx],ax		  ;

		; Is this the player ?

		cmp bx,o Player_dY	; The player ?
		jne MF_1		; No, skip

		; Alter the player's state

		mov b cs:Player_State,2	; Jumping
		mov b cs:Player_Squash,0;

		; Place it

MF_1:		mov ax,cs:dpPos[di]	; Get the position

		cmp ax,0		; Not moved ?
		je MF_2			; No, skip

		mov bx,ax		; Point at the table

		inc bx			; One more		

		mov al,cs:[bx]		; Get this offset
		cbw			;

		cmp ax,0		; End ?
		jne MF_1a		; No, skip

		mov bx,ax		; Zero the ptr

MF_1a:		mov cs:dpPos[di],bx	; Save the ptr

MF_2:		mov bx,cs:dpX[di]	; X
		mov dx,cs:dpY[di]	; Y
		add dx,ax		; Move it

		; Add it to the list

		mov ax,cs:dpF[di]	; Width
		jmp Add_Solid		;

	; The spring table

Spring_Tab	db -14,-12,-10,-8,-7,-6	; Offsets
		db -5,-4,-3,-2,-1,0	;

; Move a bridge, LHS

Move_Bridge_L:	mov ax,cs:dpPos-lPlat[di] ; (Next) posn
		jmp s MBM_0		; As below

; Move a bridge, RHS

Move_Bridge_R:	mov ax,cs:dpPos+lPlat[di] ; (Prev) posn
		jmp s MBM_0		; As below

; Move a bridge, single

Move_Bridge_S:	mov ax,0		; Default
		jmp s MBM_0		; As below

; Move a bridge, not an end

Move_Bridge_M:	mov ax,cs:dpPos-lPlat[di] ; (Next) posn
		add ax,cs:dpPos+lPlat[di] ; (Prev) posn

MBM_0:		sar ax,1		; Average of neighbours
		sub ax,cs:dpPos[di]	; Difference

		; This represents the 'springiness' of the bridge

		test b cs:dpFlags[di],2	; Is the player standing on this slat ?
		je MBM_1		; No, skip

		and b cs:dpFlags[di],0FDh ; Clear the flag

		add ax,Bridge_Man_F	; Yes, allow for it

		; Now, do we hit it hard ?

		mov bx,cs:dppOccupier[di] ; Point at the 'thing' responsible
		mov bx,cs:2[bx]		  ; Get the impact

		mov cl,3		; * 8
		shl bx,cl		;
		add ax,bx		; Allow for impact

		; ax now has the 'force' acting on this slat

MBM_1:		mov bx,ax		; Save the new force

		; Allow for friction

		mov ax,cs:dpDirn[di]	; Get the 'velocity', plus friction

		mov cl,4		; 
		sar ax,cl		; /16

		neg ax			;
		add ax,cs:dpDirn[di]	;

		add ax,bx		; Accumulate the 'velocity'
		jo MBM_3		; Overflow, skip

		mov cs:dpDirn[di],ax	;

		mov cl,3		; Scale the 'velocity'
		sar ax,cl		;

		add ax,cs:dpPos[di]	; Allow for this force
		jo MBM_3		; Clip

		mov bx,ax		; Half way ?
		add bx,bx		;
		jo MBM_3		;

		; Show it

		mov cs:dpPos[di],ax	; Set the posn

MBM_2:		mov al,ah
		cbw

		mov bx,cs:dpX[di]	; X
		mov dx,cs:dpY[di]	; Y
		add dx,ax		; Move it

		; Add it to the list

		mov ax,9		; Width
		jmp Add_Solid		;

	; Clip if overflow

MBM_3:		mov ax,cs:dpPos[di]	; Giz the posn
		jmp s MBM_2		; Back

; Move a floater

Move_Float:	mov ax,cs:dpPos[di]	; Posn

		test w cs:dpFlags[di],2	; On this one ?
		jz MF_a			; No, skip

		add ax,cs:dpDirn[di]	; Move it

		jmp s MF_b		; Skip

	; Not on it

MF_a:		cmp ax,0		; Top ?
		jz MF_b			; Yes, skip

		sub ax,cs:dpDirn[di]	; Move it

MF_b:		and w cs:dpFlags[di],0FFFDh ; Clear the flag

		; Show it

		mov cs:dpPos[di],ax	; Set the posn

		mov bx,cs:dpX[di]	; X
		mov dx,cs:dpY[di]	; Y
		add dx,ax		; Move it

		; Add it to the list

		mov ax,16		; Width
		jmp Add_Solid		;

; Move a latching floater

Move_F_Latch:	mov ax,cs:dpPos[di]	; Posn

		test w cs:dpFlags[di],2	; On this one ?
		jz MFL_Set		; No, skip

		and w cs:dpFlags[di],0FFFDh ; Clear the flag

		mov bx,cs:dpMax[di]	; Max (move cnt)
		dec bx			; Dec wait
		jnz MFL_Pause		; Not yet, skip

		; Move it

		add ax,cs:dpDirn[di]	; Move it

		mov cs:dpPos[di],ax	; Set the posn

		jmp s MFL_Set		; Skip

	; Stay where we are

MFL_Pause:	mov cs:dpMax[di],bx	; Save the new count

		; Drive it

MFL_Set:	mov bx,cs:dpX[di]	; X
		mov dx,cs:dpY[di]	; Y
		add dx,ax		; Move it

		; Add it to the list

		mov ax,16		; Width
		jmp Add_Solid		;

; Move a falling floater

Move_F_Fall:	mov ax,cs:dpPos[di]	; Posn

		test w cs:dpFlags[di],2	; On this one ?
		jz MFL_Set		; No, skip

;		and w cs:dpFlags[di],0FFFDh ; Clear the flag

		mov bx,cs:dpMax[di]	; Max (move cnt)
		dec bx			; Dec wait
		jnz MFL_Pause		; Not yet, skip

		; Move it

		mov bx,ax		; Save the posn

		mov cl,cs:dpDirn[di]	; Move it
		mov al,cs:dpDirn+1[di]	;
		cbw			;

		add cs:dppTable[di],cl	; fX
		adc ax,bx		;

		add w cs:dpDirn[di],mff_Grav ; Fall

		; In range ?

		cmp ax,64*16		; In range ?
		jae MFF_Kill		; No, kill it

		mov cs:dpPos[di],ax	; Set the posn

		jmp s MFL_Set		; Skip

	; Kill this platform

MFF_Kill:	mov ax,o rts		; Return
		mov cs:dppMove[di],ax	; Null
		mov cs:dppDraw[di],ax	;

rts:		ret			; Done

; Move a bouncer

Move_Bounce:	mov ax,cs:dpPos[di]	; Posn

		test w cs:dpFlags[di],2	; On this one ?
		jz MB_a			; No, skip

		add ax,cs:dpDirn[di]	; Move it

		jmp s MB_b		; Skip

	; Not on it

MB_a:		cmp ax,0		; Top ?
		jz MB_b			; Yes, skip

		sub ax,cs:dpDirn[di]	; Move it

MB_b:		and w cs:dpFlags[di],0FFFDh ; Clear the flag

		; Show it

		mov cs:dpPos[di],ax	; Set the posn

		mov bx,cs:dpX[di]	; X
		mov dx,cs:dpY[di]	; Y
		add dx,ax		; Move it

		; Add it to the list

		mov ax,16		; Width
		jmp Add_Solid		;

; Move it

Move_Swing:	mov ax,cs:dpPos[di]	; Posn
		mov bx,cs:dpDirn[di]	; Dirn

		test w cs:dpFlags[di],2	; On this one ?
		jz MS_a			; No, skip

;		mov w cs:Player_dY,-8*256
;		mov b cs:Player_State,2
;		mov b cs:Player_Squash,0; Not squashed

MS_a:		and w cs:dpFlags[di],0FFFDh ; Clear the flag
		add ax,bx		; Move

		cmp ax,cs:dpMax[di]	; End ?
		jae MS_Clip		; Yes, clip it

		; Show it

MS_1:		mov cs:dpPos[di],ax	; Set the posn

		; Now, calc it's position on screen

		add ax,ax		; * 4
		add ax,ax		;

		add ax,cs:dppTable[di]	; Point at the table

		mov bx,cs:dpX[di]	; X
		mov dx,cs:dpY[di]	; Y

		mov si,ax		; Pointer

		; Now, show it

		add bx,cs:[si]		; Get the X
		add dx,cs:2[si]		; Get the Y

		; Add it to the list

		mov ax,16		; Width
		jmp Add_Solid		;

	; Clip the swing count

MS_Clip:	neg bx			; Invert dirn
		mov cs:dpDirn[di],bx	;

		add ax,bx		; Move back

		jmp MS_1		; Show it

; Draw a swinging one one

Draw_Swing:	mov ax,cs:dpPos[di]	; Posn

		add ax,ax		; * 4
		add ax,ax		;

		add ax,cs:dppTable[di]	; Point at the table

		mov bx,cs:dpX[di]	; X
		add bx,bx		; * 8
		add bx,bx		;
		add bx,bx		;

		mov dx,cs:dpY[di]	; Y
		add dx,dx		; * 8
		add dx,dx		;
		add dx,dx		;

		push di			; Save the ptr

		mov di,ax		; Pointer

		; Now, show it

		mov ax,cs:[di]		; Get the X
		mov cs:MP_X,ax		;

		mov ax,cs:2[di]		; Y
		mov cs:MP_Y,ax		;

		mov ch,8		; Ten rings

		mov ax,iCentre		; Centre

MP_Lp:		push bx			; Save
		push cx			;
		push dx			;

		mov cl,3		; /8
		sar bx,cl		;
		sar dx,cl		;

		call Draw_Sprite	; Show a ring

		mov ax,iLink		; Use this next time

		pop dx			;
		pop cx			;
		pop bx			;

		add bx,cs:MP_X		; Accumulate them
		add dx,cs:MP_Y		;

		dec ch			; Loop
		jne MP_Lp		;

		; Add the platform to this link

		mov cl,3		; /8
		sar bx,cl		;
		sar dx,cl		;

		mov ax,iPlat		; Show this

		push bx			; Save X
		push dx			;
		call Draw_Sprite	;
		pop dx			; Restore
		pop bx			;

		pop di			; Restore

		ret			; Done

; Draw one

Draw_Cordless:	mov ax,cs:dpPos[di]	; Posn

		add ax,ax		; * 4
		add ax,ax		;

		add ax,cs:dppTable[di]	; Point at the table

		mov bx,cs:dpX[di]	; X
		mov dx,cs:dpY[di]	; Y

		push di			; Save the ptr

		mov di,ax		; Pointer

		; Now, show it

		add bx,cs:[di]		; Get the X
		add dx,cs:2[di]		; Y

		mov ax,iPlat1		; Show this
		call Draw_Sprite	;

		pop di			; Restore

		ret			; Done

; Draw a simple flat one

Draw_Flat:	mov dx,cs:dpPos[di]	; Posn

		add dx,cs:dpY[di]	; Y

;		call Get_Player_Sq	; Squashed ammount
;		mov ah,0		;

;		add dx,ax		; Move down by it * 2
;		add dx,ax		;

		mov bx,cs:dpX[di]	; X

		push di			; Save the ptr

		; Now, show it

		mov ax,iPlat1		; Show this
		call Draw_Sprite	;

		pop di			; Restore

		ret			; Done

; Draw a simple flat one, where dpPos is / 256

Draw_Bridge:	mov al,cs:dpPos+1[di]	; Posn
		cbw			;

		add ax,cs:dpY[di]	; Y
		mov dx,ax		;
		mov bx,cs:dpX[di]	; X

		push di			; Save the ptr

		; Now, show it

		mov ax,iPlat3		; Show this
		call Draw_Sprite	;

		pop di			; Restore

		ret			; Done

; Draw a spring

Draw_Spring:	mov ax,cs:dpPos[di]	; Posn
		cmp ax,0		; 0 ?
		je DS_1			; Skip

		mov bx,ax		; Get the entry
		mov al,cs:[bx]		;
		cbw			;

DS_1:		mov dx,cs:dpY[di]	; Y
		add dx,ax		;
		mov bx,cs:dpX[di]	; X

		push di			; Save the ptr

		; Now, show it

		mov ax,iPlat2		; Show the spring
		call Draw_Sprite	;

		pop di			; Restore

		ret			; Done

; Vars

		align 2			; Even

MP_X		dw ?			; Vector to platform
MP_Y		dw ?			;

Platforms	db lPlat * nPlats dup (?)	; The first ones' posn, etc
