Proj_Range	equ 100			; Fire from this far

; Right, fire something at the player, with speed AX

Fire_At_Man:	mov dx,ax		; Save

		; Is this in range ?

		mov ax,cs:Player_X	; Target
		sub ax,cs:d_X[di]	; Our X
		mov cs:Temp_dX,ax	; Save		

		; Is this in range ?

		cmp ax,0		; +/-
		jns FAM_Pve		; Skip

		neg ax			; Abs

FAM_Pve:	cmp ax,Proj_Range	; In range ?
		jb FAM_X_Ok		; Yes, try it

		ret			; Done, out of range

	; Is this in range ?

FAM_X_Ok:	mov ax,cs:Player_Y	; Target
		sub ax,12		; Middle

		sub ax,cs:d_Y[di]	; Our X
		mov cs:Temp_dY,ax	; Save		

		; Is this in range ?

		cmp ax,0		; +/-
		jns FAM_Y_Pve		; Skip

		neg ax			; Abs

FAM_Y_Pve:	cmp ax,Proj_Range	; In range ?
		jb FAM_Fire		; Yes, try it

		ret			; Done, out of range

vFAM_X:		jmp FAM_X		; Exit vector

	; Try to fire

FAM_Fire:	mov si,di		; Point at the source

		; Get some free space

		call Get_Free		; Find a free space
		jc vFAM_X		; Can't, exit

		; Set it to the thing's position

		; X

		mov ax,cs:d_X[si]	; X
		mov cs:d_X[di],ax	;
		mov b cs:d_frac_X[di],0	;

		; Y

		mov ax,cs:d_Y[si]	; Y
		mov cs:d_Y[di],ax	;
		mov b cs:d_frac_Y[di],0	;

		; Now, calculate the vector to the man

		; X

		mov ax,cs:Temp_dX	; Get it
		mov cx,ax		; Save
		mov cs:ddX[di],ax	; temp

		; Y

		mov ax,cs:Temp_dY	; Target
		mov bx,ax		;

		; Now, we must scale these to get the required speed.

		cmp cx,0		; dX +ve ?
		jns FAM_ND_1		; Yes, skip

		neg cx			; Abs dX

FAM_ND_1:	cmp ax,0		; dY +ve ?
		jns FAM_ND_2		; Yes, skip

		neg ax			; Abs dX

FAM_ND_2:	add cx,ax		; |dx| + |dY|
		inc cx			; NOT 0 !

		; Calc the scale speed

;		test b cs:Difficulty,02h; Slower ?
;		jnz FAM_Diff		; No, skip

;		shr dx,1		; /2 (half speed)

FAM_Diff:	mov ax,dx		; Speed
		mov dx,0		; 32-bit

		div cx			; Calc 

		; Now scale the real dX/dY

		mov cx,ax		; Scale factor
		inc cx			; NOT ZERO !

		mov ax,cs:ddX[di]	; dX
		imul cx			; Scale it
		mov cs:ddX[di],ax	;

		mov ax,bx		; dY
		imul cx			; Scale it
		mov cs:ddY[di],ax	;

		; Shape

		call Rand_32
		mov cs:dShape[di],al

		; Alive

		mov b cs:dFlags[di],01h	; Make it live, aimed at things

		; Setup life

;		mov al,cs:optProj_Life	; Lifetime
		mov ah,0		;

	mov al,240

		add ax,ax		; * 4
		add ax,ax		;

		mov cs:dLife[di],ax	;

		; Set the follow rate

		mov ax,25		; 1/2 sec follow
		mov w cs:dnStep[di],ax	; Set it
		mov w cs:dcStep[di],ax	;

		; Add it to the list

		call Add_Proj		; Add it to the list

		; Add the driver

		mov ax,o Move_Proj	; Routine
		mov cs:dpMove[di],ax	;

		; Done, exit

	call Rand_32
	mov cs:dShape[di],al

FAM_X:		mov di,si		; Restore ptr
		ret			;

; Code to move the projectiles, entry with di pointing at data

Move_Proj:

;	inc w cs:dLife[di]	; Prevent TO

		;test cs:dFlags[di],1	; Follow ?
		;jz MP_GotDir		; No, skip

		mov ax,cs:dcStep[di]	; Time to change dirn ?
		dec ax			;
		jnz MP_GotDir		; Yes, skip

		; Calc vector

		; X

		mov al,b cs:Cheap_Rand
		and al,31
		sub al,15
		cbw
		add ax,cs:Player_X	; Target

		sub ax,cs:d_X[di]	; Our X
		mov cx,ax		; Save
		mov si,ax		;

		; Y

		mov al,b cs:Cheap_Rand+1
		and al,31
		sub al,15
		cbw
		add ax,cs:Player_Y	; Target

		sub ax,70;12		; Middle of man
		sub ax,cs:d_Y[di]	; Our 
		mov bx,ax		; Save dY

		; Now, we must scale these to get the required speed.

		cmp cx,0		; dX +ve ?
		jns MP_ND_1		; Yes, skip

		neg cx			; Abs dX

MP_ND_1:	cmp ax,0		; dY +ve ?
		jns MP_ND_2		; Yes, skip

		neg ax			; Abs dX

MP_ND_2:	add cx,ax		; |dx| + |dY|
		inc cx			; NOT 0 !

		; Calc the scale speed

		mov dx,0		; 32-bit
		mov ax,500;cs:dTargSpeed[di];

		div cx			; Calc 

		; Now scale the real dX/dY

		mov cx,ax		; Scale factor
		inc cx			; NOT ZERO !

		mov ax,si		; dX
		imul cx			; Scale it
		mov cs:ddX[di],ax	;

		mov ax,bx		; dY
		imul cx			; Scale it
		mov cs:ddY[di],ax	;

		; Move

		mov ax,cs:dnStep[di]	; Next time

MP_GotDir:	mov cs:dcStep[di],ax	; Save time

		mov bx,cs:ddX[di]	; Move it in X
		mov al,bh		; Make 24-bit
		cbw			;

		add cs:d_frac_X[di],bl	; Step it
		adc ax,cs:d_X[di]	;
		mov cs:d_X[di],ax	;

		mov bx,ax		; Save X

		; Move in Y

		mov dx,cs:ddY[di]	; Move it in Y
		mov al,dh		; Make 24-bit
		cbw			;

		add cs:d_frac_Y[di],dl	; Step it
		adc ax,cs:d_Y[di]	;
		mov cs:d_Y[di],ax	;

		mov dx,ax		; Save Y

		; Is this a hit on the man ?

		mov ax,cs:Player_LHS	; < LHS ?
		cmp ax,bx		;
		jnc MP_1		; No, skip

		mov ax,cs:Player_RHS	; > RHS ?
		cmp bx,ax		;
		jnc MP_1		; No, skip

		mov ax,cs:Player_TOP	; < TOP ?
		cmp ax,dx		;
		jnc MP_1		; No, skip

		mov ax,cs:Player_BOTT	; > BOTT ?
		cmp dx,ax		;
		jnc MP_1		; No, skip

		; Make it a fizzle

		mov cx,o Move_Fizzle	; Move routine
		mov ax,8		; Short
		call Create_Fizzle	; Add it

		; A hit, a palpable hit

		mov al,1		; Small damage
		call Sub_Health		;

		; Done, exit

		jmp s MP_Fail		; Kill it

		; Show it

MP_1:		mov al,cs:dShape[di]	; 
		rol al,1
		mov cs:dShape[di],al

;	jmp Draw_Eye

		shr al,7
		and al,1
		add al,iFly1		; Sprite
		mov ah,0		; Make the sprite number 16-bit

		push di			; Save
		call Draw_Sprite	; Show it
		pop di			;

;		cmp al,0		; Drawn ?
;		jz MP_Fail		; No, skip

		clc			; OK
		ret			; Done/Not shown

MP_Fail:	stc			; Fail
		ret			;

; Vars

Temp_dX		dw ?			;
Temp_dY		dw ?			;
