; All these sources/objects are (c) Simon Brattel 1992

		include ..\symbols.inc	; Define them
		include gsymbols.inc	;

CODE		SEGMENT public 		;

		ASSUME  CS:CODE		;

; Filenames

sTitle		db "e:\dpaint2\pictures\title.lbm",0	; Palette
sSource		db "e:\dpaint2\pictures\back.lbm",0	; Background
sSource1	db "e:\dpaint2\pictures\player.lbm",0	; Player
sSource2	db "e:\dpaint2\pictures\blocks.lbm",0	; Sprites

sDest		db "s_salad1.sp0",0	; Dest

Start:		mov ax,StackSeg		; get Stack Segment Origin
		mov SS,ax		; and initialize the SS register
		mov SP,o TOS		; set SP to Top Of Stack

		; Free surplus RAM

		call Deallocate		; Release it

		; Now, read the title file

		call Read_Title		; Get it
		jc Exit			; Fail

		; Get the title palette

		call Read_Pal_T		; Get it

		; Now, read the source file

		call Read_Source	; Get it
		jc Exit			; Fail

		; Get the block palette

		call Read_Pal_1		; Get it

		; Draw the file

		call Draw_Screen	; Draw into the screen buffer

		; Create the sprite-file

		call Open_Sprites	; Create the file

		; Now, we have the file, convert it

		call Convert		; Convert it

		; Now, get the next screen

		; Now, read the next source file

		call Read_Source1	; Get it
		jc Exit			; Fail

		; Get the sprite palette

		call Read_Pal_2		; Get it

		; Draw the file

		call Draw_Screen	; Draw into the screen buffer

		; Now, we have the file, convert it

		call Convert		; Convert it

		; Now, read the next source file

		call Read_Source2	; Get it
		jc Exit			; Fail

		; Get the sprite palette

		call Read_Pal_3		; Get it

		; Draw the file

		call Draw_Screen	; Draw into the screen buffer

		; Now, we have the file, convert it

		call Convert		; Convert it

		; Close the file
	
		call WF_Close		; End it

	; The exit message

Exit:		mov ah,terminate	;
		int dos			; Done

; Convert the file

Convert:	mov ax,DATA2		; The screen
		mov ds,ax		;

		mov si,o Screen		; Point at the display buffer

		; 200 lines

		mov cx,200-2		; This many (ignore the last 2 lines)

Conv_Lp:	push cx			; Save

		mov cx,320-2		; Width (ignore the last 2 pixels)

C_Lp1:		mov al,ds:[si]		; Get the next pixel
		cmp al,1		; Is this a border (Col=1)
		je C_TL			; Yes, skip

C_Next:		inc si			; Skip

		loop C_Lp1		; Loop

		add si,2		; Move to the next line

		pop cx			; Restore
		loop Conv_Lp		; Loop

		ret			; Done

	; This is a valid border pixel, is it the top-left one ?

C_TL:		mov al,ds:1[si]		; Next pixel
		dec al			; 1 or 2 ?
		cmp al,1		;
		ja C_Next		; Skip

		mov al,ds:320[si]	; Next line
		dec al			; 1 or 2 ?
		cmp al,1		;
		ja C_Next		; Skip

		; OK, this is a valid top-left pixel. Define the sprite.

		push si			; Save the ptr
		push cx			; Save the count

		call Define_Sprite	; Define it

		pop cx			; Restore
		pop si			;

		jmp s C_Next		; Loop

; Define a putative sprite.

Define_Sprite:	call Find_Border	; Find the border, etc
		jc DS_X			; Can't, exit

		; This is valid, we must generate some code.

		call Add_Sprite		; Add the sprite to the sprite-defns

		call Generate_Code	; Generate the code to draw it

DS_X:		ret			; Done

; Add the sprite to the sprite-defns

Add_Sprite:	mov ax,cs:Sprite_No	; Get the sprite-no.
		inc w cs:Sprite_No	; + 1

		add ax,ax		; * 2
		add ax,o Sprite_Ptrs	; + base

		mov bx,ax		; Point at it

		mov ax,cs:Sprite_F_Off	; Offset into the file
		mov cs:[bx],ax		; Store it

		ret			; Done

; Generate the code to draw the sprite

Generate_Code:	mov ax,DATA		; Point at the code-buffer
		mov es,ax		;

		mov di,o Sprite_Code	; Point at the code

		; Now, scan across/down,producing code

		mov ax,0		; Clear the colour bytes
		mov cs:Reg_0,ax		;
		mov cs:Reg_1,ax		;
		mov cs:Reg_2,ax		;
		mov cs:Reg_3,ax		;

		mov cs:Reg_Ptr,al	;

		mov dx,cs:Sweet_Ptr	; Offset from the sweet-spot
		neg dx			;

		mov bp,0		; Current offset

		mov cx,cs:S_Height	; Height

GS_Y_Lp:	push cx			; Save

		mov cx,cs:S_Width	; Width

GS_X_Lp:	mov al,ds:[si]		; Get the next pixel
		inc si			; Skip

		cmp al,0		; Mask ?
		jnz GS_Pixel		; No, skip

GS_NP:		inc dx			; Step ptr

		dec cx			; Loop
		jnz GS_X_Lp		;

		; Move down (output)

		sub dx,cs:S_Width	; Back
		add dx,X_Step		; Down

		; (source)
		
		lea si,320[si]		; Move down
		sub si,cs:S_Width	;

		pop cx			; Restore
		loop GS_Y_Lp		; Loop

		jmp Finish_Code		; Done, write it

	; We have a pixel, do summat wi' it

GS_Pixel:	mov bx,dx		; Get the offset
		sub bx,bp		; From the current posn
		jz GSP_NoOffset		; None, skip

		; Is this offset small enough to be INC's ?

		cmp bx,2		; >2 ?
		ja GSP_LEA		; No, skip

		mov b es:[di],047h	; "INC DI"
		inc di			;

		cmp bx,1		; 1 ?
		je GSP_NoOffset		; Yes, skip

		; Assume 2

		mov b es:[di],047h	; "INC DI"
		inc di			;

		jmp s GSP_NoOffset	; Skip

	; Plant an LEA instr.

GSP_LEA:	cmp bx,127		; 8-bit ?
		jae GSP_LEA_16		; No, skip

		mov w es:[di],07D8Dh	; LEA DI,nnnn[di]
		mov es:2[di],bl		; nn
		lea di,3[di]		; Skip

		jmp s GSP_NoOffset	; Skip

	; 16-bit LEA

GSP_LEA_16:	mov w es:[di],0BD8Dh	; LEA DI,nnnn[di]
		mov w es:2[di],bx	; nnnn
		lea di,4[di]		; Skip

	; Find a suitable register

GSP_NoOffset:	mov bp,dx		; Update the current offset

		mov ah,0		; "AL"

		mov bx,cs:Reg_0		; Get AL/CL

		cmp al,bl		; AL ?
		je GSP_GR		; Yes, skip

		inc ah			; 1

		cmp al,bh		; CL ?
		je GSP_GR		; Yes, skip

		mov bx,cs:Reg_1		; Get DL/BL

		inc ah			; 2

		cmp al,bl		; DL ?
		je GSP_GR		; Yes, skip

		inc ah			; 3

		cmp al,bh		; BL ?
		je GSP_GR		; Yes, skip

		mov bx,cs:Reg_2		; Get AH/CH

		inc ah			; 4

		cmp al,bl		; AH ?
		je GSP_GR		; Yes, skip

		inc ah			; 5

		cmp al,bh		; CH ?
		je GSP_GR		; Yes, skip

		mov bx,cs:Reg_3		; Get DH/BH

		inc ah			; 6

		cmp al,bl		; DH ?
		je GSP_GR		; Yes, skip

		inc ah			; 7

		cmp al,bh		; BH ?
		je GSP_GR		; Yes, skip

		; It is not in a register, load it into the next one

		mov ah,cs:Reg_Ptr	; Point at the first free one
		and ah,07h		; Mask

		inc b cs:Reg_Ptr	; Step the ptr

		mov bl,ah		;
		mov bh,0		;
		add bx,o Reg_0		;

		mov cs:[bx],al		; Save this colour

		; Plant the "MOV RR,NN"

		or ah,0B0h		; Make the MOV RR op-code

		mov es:[di],ah		; Plant it
		inc di			;
		mov es:[di],al		; Plant nn
		inc di			;

		and ah,07h		; RR

		; Now, store the register

GSP_GR:		cmp al,ds:[si]		; Is the next pixel the same ?
		je GS_Word		; Yes, skip

		; Cope with a single pixel

GS_Single:	add ah,ah		; * 8
		add ah,ah		;
		add ah,ah		;

		or ah,05h		; Make op-code

		mov b es:[di],088h	; "MOV [di],rr"
		inc di			;

		mov es:[di],ah		; RR
		inc di			;

		; Done, exit

		jmp GS_NP		; Pixel done

	; We have a pair of similar pixels, first setup the 16-bit register

	; ah = register (8-bit) number

GS_Word:	inc si			; Skip the extra pixel

		mov bl,ah		; Get the register spec
		and bx,0003h		; Clip to the low byte

		add bx,o Reg_0		; Point at the data

		test ah,04h		; xL or xH ?
		jnz GSW_High		; High one

		; We have the colour in the low byte, is the same colour in the
		; high byte ?

		cmp al,cs:4[bx]		; Same ?
		je GSW_GRRRR		; Yes, skip

		mov cs:4[bx],al		; Now the same

		; plant the MOV xH,xL

		mov bl,ah		; Get SRC
		or bl,1Ch		; DST + op-code

GW_Move:	shl bl,1		; Align
		shl bl,1		;
		shl bl,1		;

		or bl,ah		; + SRC		

		mov b es:[di],08Ah	; MOV xH,xL
		inc di			;

		mov es:[di],bl		; xH,xL
		inc di			;

		; Plant the move

GSW_GRRRR:	and ah,03h		; Mask RRRR

	     	add ah,ah		; * 8
		add ah,ah		;
		add ah,ah		;

		or ah,05h		; Make op-code

		mov b es:[di],089h	; "MOV [di],rrrr"
		inc di			;

		mov es:[di],ah		; RRRR
		inc di			;

		; Done, exit

		inc dx			; Step ptr
		dec cx			; Dec count

		jmp GS_NP		; Pixel done

	; We have the colour in the high byte, the low is different

GSW_High:	mov cs:[bx],al		; Now the same

		; plant the MOV xH,xL

		mov bl,ah		; Get SRC
		and bl,03h		; LOW

		or bl,18h		; DST + op-code

		; Plant the move, etc

		jmp s GW_Move		; As above

	; Done, write the buffer to disk

Finish_Code:	mov b es:[di],0CBh	; Add a RETF
		inc di			; Step the ptr

		; Now, align to a segment-boundary

		mov cx,o Sprite_Code	; Get the ptr offset
		sub cx,di		;
		and cx,0Fh		; 0 .. 15
		jz FC_1

FC_Lp:		mov b es:[di],000h	;
		inc di			;

		loop FC_Lp		;

		; Get the length

FC_1:		mov cx,di		; Ptr
		sub cx,o Sprite_Code	;

		; Write this length to the file

		push cx			; Save the length

		push ds			; Save

		mov ax,DATA		;
		mov ds,ax		; Seg

		mov bx,o Sprite_Code	; Offset
		call Save_Block		; Write to the file

		pop ds			; Restore

		pop cx			; Restore

		shr cx,1		; /16
		shr cx,1		;
		shr cx,1		;
		shr cx,1		;

		add cs:Sprite_F_Off,cx	; Skip this sprite

		ret			; Done

; Now, given si as a ptr to a top-left, get the sprite-window

Find_Border:	mov bx,si		; Top-Left
		mov cx,0		; Offset count
		mov dx,0		; Offset

		; Find the RHS/BORDER

FB_RHS_Lp:	inc dx			; Inc count
		inc bx			; Move the ptr

		mov al,ds:[bx]		; Giz the pixel
		cmp al,1		; Border ?
		je FB_RHS_Lp		; Yes, loop

		cmp al,2		; Marker ?
		jne FB_RHS		; No, this is the RHS

		; This is the marker, mark it

		test cx,0		; Marker already ?
		jne FB_Fail		; Yes, skip

		mov cx,dx		; Save the count

		jmp s FB_RHS_Lp		; Loop

	; We have the RHS, save the vars

FB_RHS:		dec cx			; Offset marker - 1
		mov cs:Sweet_Ptr,cx	; Save it

		sub dx,2		; Width
		mov cs:S_Width,dx	;

		; Save the next-sprite ptr

		mov cs:Scr_Ptr,si	; Save it

		; Now, find the bottom

		mov bx,si		; Skip the pixel
		mov cx,0		; Offset count
		mov dx,0		; Offset

		; Find the BOTTOM/BORDER

FB_BOTT_Lp:	inc dx			; Inc count
		add bx,320		; Move the ptr

		mov al,ds:[bx]		; Giz the pixel
		cmp al,1		; Border ?
		je FB_BOTT_Lp		; Yes, loop

		cmp al,2		; Marker ?
		jne FB_BOTT		; No, this is the BOTT

		; This is the marker, mark it

		test cx,0		; Marker already ?
		jne FB_Fail		; Yes, skip

		mov cx,dx		; Save the count

		jmp s FB_BOTT_Lp	; Loop

	; We have the bottom, save the vars

FB_BOTT:	sub dx,2		; Height
		mov cs:S_Height,dx	;

		; Calc the sweet-spot offset

		mov ax,cx		; Y-Offset
		dec ax			;
		mov dx,0		;

		mov cx,X_Step		; Step
		mul cx			; Calc the offset in Y

		add cs:Sweet_Ptr,ax	; Add X

		; Now, point at the first

		lea si,321[si]		; Point at the first pixel

		clc			; Ok
		ret			;

FB_Fail:	stc			; Fail
		ret			;

; Read the palette

Read_Pal_T:	mov ax,DATA2		; The data-area
		mov ds,ax		;

		; Now, get the palette

		mov si,0033h+o File	; HACK ! this is the start of the CMAP
		mov di,o Palette	; Point at the first block

		mov cx,010h*3		; This many colours

		mov w cs:[di],0		; Clear colour 0
		mov b cs:2[di],0	;

		lea di,3[di]		;

RPT:		mov al,es:[si]		; Giz the value
		inc si			;

		shr al,1		; / 4
		shr al,1		;

		mov cs:[di],al		; Store it
		inc di			;

		loop RPT		; Loop

		ret			; DOne

; Read the palette

Read_Pal_1:	mov ax,DATA2		; The data-area
		mov ds,ax		;

		; Now, get the palette

		mov si,0030h+o File+10h*3 ; HACK ! this is the start of the CMAP
		mov di,o Palette+10h*3	; Point at the first block

		mov cx,020h*3		; This many colours

RP1:		mov al,es:[si]		; Giz the value
		inc si			;

		shr al,1		; / 4
		shr al,1		;

		mov cs:[di],al		; Store it
		inc di			;

		loop RP1		; Loop

		ret			; DOne

; Read the palette

Read_Pal_2:	mov ax,DATA2		; The data-area
		mov ds,ax		;

		; Now, get the palette

		mov si,0030h+o File+30h*3 ; HACK ! this is the start of the CMAP
		mov di,o Palette+030h*3	; Point at the first block

		mov cx,10h*3		; This many colours

RP2:		mov al,es:[si]		; Giz the value
		inc si			;

		shr al,1		; / 4
		shr al,1		;

		mov cs:[di],al		; Store it
		inc di			;

		loop RP2		; Loop

		ret			; DOne

; Read the palette

Read_Pal_3:	mov ax,DATA2		; The data-area
		mov ds,ax		;

		; Now, get the palette

		mov si,0030h+o File+40h*3 ; HACK ! this is the start of the CMAP
		mov di,o Palette+040h*3	; Point at the first block

		mov cx,(100h-40h)*3	; This many colours

RP3:		mov al,es:[si]		; Giz the value
		inc si			;

		shr al,1		; / 4
		shr al,1		;

		mov cs:[di],al		; Store it
		inc di			;

		loop RP3		; Loop

		ret			; DOne

; Now, draw the screen

Draw_Screen:	mov ax,DATA2		; The data-area
		mov ds,ax		;

		; Now draw the picture

		mov si,03E8h+o File	; HACK ! this is the start of the BODY

		mov di,o Screen		; Point at the buffer

		mov cx,200		; Read this many lines

RB_Lp1:		push cx			; Save

		call Read_Line		; Read a pixel line

		pop cx			; Restore
		loop RB_Lp1		; Loop

		ret			; Done

; Read a pixel-line

Read_Line:	lea bp,320[di]		; Point at the end address

		mov dl,01h		; This bit
		mov dh,00h		; Mask

RL_Lp:		push di			; Read a block
		call Read_Line_Bit	; Read a bit
		pop di			;

		mov dh,0FFh		; New mask

		add dl,dl		; Shift the bit
		jnc RL_Lp		; Loop

		; Skip this line

		mov di,bp		; Skip to the next line

		ret			; Done

	; Read a line of bits

RLB_Skip:	inc si			; Skip

Read_Line_Bit:	mov al,es:[si]		; Get the next byte of the file
		inc si			; Skip

		cmp al,-127		; Ignore ?
		je RLB_Skip		; Yes, loop

		test al,080h		; -ve ?
		jnz RLB_Neg		; Yes, skip

		; Copy the next (n+1) bytes

		inc al			; n+1

RLB_C_Lp:	mov ah,es:[si]		; Copy a byte
		inc si			;

		call RLB_Write		; Write 8 bits

		dec al			; Loop
		jnz RLB_C_Lp		;

		; End of line ?

RLB_EOL:	cmp di,bp		; EOL ?
		jnz Read_Line_Bit	; No, loop

		ret			; Done

	; Copy the next byte (n+1) times

RLB_Neg:	neg al			; Negate it
		inc al			; n+1

		mov ah,es:[si]		; Copy a byte
		inc si			;

RLB_D_Lp:	call RLB_Write		; Write 8 bits

		dec al			; Loop
		jnz RLB_D_Lp		;

		jmp s RLB_EOL		; Skip

	; Write 8 bits

RLB_Write:	push ax			; Save

		mov al,8		; This many bits

RLBW_Lp:	mov bl,ds:[di]		; Mask it
		and bl,dh		;

		add ah,ah		; Test the top bit
		jnc RLBW_Z		; No, skip

		or bl,dl		; Merge it		

RLBW_Z:		mov ds:[di],bl		; Write it
		inc di			; Skip

		dec al			; Loop
		jnz RLBW_Lp		;

		pop ax			; Restore
		ret			; Done

; Read the source file

Read_Title:	mov dx,o sTitle		; Get the ^string
		jmp s RS_Read		;

Read_Source2:	mov dx,o sSource2	; Get the ^string
		jmp s RS_Read		;

Read_Source1:	mov dx,o sSource1	; Get the ^string
		jmp s RS_Read		;

Read_Source:	mov dx,o sSource	; Get the ^string

RS_Read:	push cs			; ds:dx
		pop ds			;

		mov bx,o File		; Point at the map
		mov cx,8		; Length

		mov ax,DATA1		; The segment
		mov es,ax		;

		push dx			; Save
		call Read_File		; Read it
		pop dx			; Restore

		jc RF_Exit		; Can't, exit

		; Now, get the length

		mov bx,o File + 6	; Length
		mov cx,es:[bx]		; Get the length
		xchg cl,ch		; Order them

		add cx,8		; Length (total)

		; Now read the file

		push cs			; ds:dx
		pop ds			;

		mov bx,o File		; Point at the map

		mov ax,DATA1		; The segment
		mov es,ax		;

		call Read_File		; Read it
		jc RF_Exit		; Can't, exit

		clc			; Ok

RF_Exit:	ret			; Done

; Write the destn file

Open_Sprites:	mov dx,o sDest		; Get the ^string

		push cs			; ds:dx
		pop ds			;

		mov bx,o Sprite_Ptrs	; Point at the map

		mov cx,256*(2+3)	; Length

		mov ax,CODE		; The code segment
		mov es,ax		;

		call Write_File		; Read it

		ret			; Done

; Possible read filename dx:ds, length cx, data from es:bx

Read_File:	mov cs:WF_Len,cx	; Save the length

		mov cs:WF_Off,bx	; Start of data

		mov ax,es		; Save the seg
		mov cs:WF_Seg,ax	;

		mov cx,00h		; File attribute

		mov al,0		; Read only

		mov ah,OpenFile		; Call dos
		int dos			;

		jc PRF_Exit		; Can't open file

		mov cs:ReadHandle,ax	; Save the handle

		; Rewind to start

		mov cx,0		; Rewind file
		mov dx,0		;

		mov bx,ax		; Handle

		mov al,0		;

		mov ah,MovePointer	;
		int dos			;

		; Read the file

		mov ax,cs:WF_Seg	; Segment
		mov ds,ax		;

		mov bx,cs:WF_Off	; Offset

		mov cx,cs:WF_Len	; Length

		call Read_Block		; Write it

		; Close the file

		push ax			; Save error code

		mov bx,cs:ReadHandle	; Close it
		mov ah,CloseFile	;
		int dos			;

		pop ax			;

		; Done

PRF_Exit:	ret			; Done

; Write filename dx:ds, length cx, data from es:bx

Write_File:	mov cs:WF_Len,cx	; Save the length

		mov cs:WF_Off,bx	; Start of data

		mov ax,es		; Save the seg
		mov cs:WF_Seg,ax	;

		mov cx,00h		; File attribute

		mov ah,CreateFile	; Call dos
		int dos			;

		jc WF_Fail		; Can't create file

		mov cs:TempHandle,ax	; Save the handle

		; Write the keys

		mov ax,cs:WF_Seg	; Segment
		mov ds,ax		;

		mov bx,cs:WF_Off	; Offset

		mov cx,cs:WF_Len	; Length

		call Save_Block		; Write it

		; Done

WF_Fail:	ret			; Done

; Re-wind the file

WF_Rewind:	mov cx,0		; Rewind file
		mov dx,0		;

		mov bx,cs:TempHandle	; Handle

		mov al,0		;

		mov ah,MovePointer	;
		int dos			;

		ret			; Done

; Close the file

WF_Close:	call WF_Rewind		; Back to the start

		push cs			; Get the seg
		pop ds			;

		mov bx,o Sprite_Ptrs	; Offset

		mov cx,256*(2+3)	; Length

		call Save_Block		; Write to the file

		push ax			; Save error code

		mov bx,cs:TempHandle	; Close it
		mov ah,CloseFile	;
		int dos			;

		pop ax			;

		ret			; Done

; Write block ds:bx for length cx

Save_Block:	push ax			; Save reg
		push dx			;

		mov dx,bx		; Get ptr

		mov bx,cs:TempHandle	; Get file handle

		mov ah,WriteToFile	; Write it
		int dos			;
		jc SB_Fail		; Fail

		cmp ax,cx		; Save full length ?
		jz SB_OK		; Yes, skip

		stc			; Assert fail

SB_Fail:	pop dx			; Restore
		pop ax			; dummy

		mov al,64		; "Disc full"

		ret			;

SB_OK:		pop dx			; Restore
		pop ax			;

		ret			;

; Read block ds:bx for length cx

Read_Block:	push ax			; Save reg
		push dx			;

		mov dx,bx		; Get ptr

		mov bx,cs:ReadHandle	; Get file handle

		mov ah,ReadFromFile	; Read it
		int dos			;
		jc SB_Fail		; Fail

		cmp ax,cx		; Save full length ?
		jz SB_OK		; Yes, skip

		stc			; Assert fail

		jmp SB_Fail		; Fail

; Vars

WF_Len		dw ?			; Length
WF_Seg		dw ?			; Segment
WF_Off		dw ?			; Offset

TempHandle	dw ?			; Handle
ReadHandle	dw ?			; Handle for reading

; Release the unused RAM

Deallocate:	mov bx,o TOS		; Point at top of ss

		mov cl,4		; Convert to paragraphs
		shr bx,cl		;
		inc bx			; add one for luck

		mov cx,ss		; Get stack segment
		add bx,cx		; Add stack segment
		
		mov cx,es		; Get extra segment
		sub bx,cx		; Subtract it

		; bx contains no. of paragraphs from es to the top of ss

		mov ah,Set_Block	; Deallocate surplus RAM
		int dos			;

		mov al,9		; "Internal memory"
		ret			;

; Vars

pBlocks		dw ?			; Pointer

Sweet_Ptr	dw ?			; Offset the the 'sweet spot'
S_Width		dw ?			; X-size
S_Height	dw ?			; Y-size

Scr_Ptr		dw ?			; Ptr to the next screen pos

Sprite_No	dw 0			; 0

Reg_0		dw ?			; Register colours
Reg_1		dw ?			;
Reg_2		dw ?			;
Reg_3		dw ?			;

Reg_Ptr		db ?			;

		; Note, the following are saved as 256 words

Sprite_Ptrs	dw 255 dup (?)		; The offsets to the sprite-code
Sprite_F_Off	dw 0			; Offset to the first one

Palette		db 256*3 dup (?)	; The palette

		;

CODE		ends

; Data

DATA		SEGMENT byte public	; A segment for the fonts

Sprite_Code	db 65535 dup (?)	; Build them into here

DATA		ends			; End it

DATA1		SEGMENT byte public	; A segment for the file

File		db 65535 dup (?)	; Load it into here

DATA1		ends			; End it

DATA2		SEGMENT byte public	; A segment for the graphics

Screen		db 320*200 dup (?)	; Draw it into here
Screen_End	equ this byte		;

DATA2		ends			; End it

StackSeg	segment stack

		dw 400 dup (?)
TOS		equ this word

StackSeg	ends

		end Start

